Unit Calculator;

interface

uses
  SysUtils;

const
 OperSet:set of char=
  ['+','-','*','/','(',')'];
 NumSet:set of char=
  ['0','1','2','3','4','5','6','7','8','9','.'];
 VarSet:set of char=
  ['x','y'];
 FuncSet:set of char=
  ['a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s',
   't','u','w','v','z'];
 Oper:array[-2..4] of char=
  ('c','s',' ','*','/','+','-');
 maxstack=1000;
 maxstack1=1000;
 maxrec=200;

type
 TMathRec=record
  Number:real;
  Code:ShortInt;
 end;
 TMathRecord=record
  I:array[1..maxrec] of TMathRec;
  Length:word
 end;
 TStackArr=
  array[1..maxstack] of Real;
 TStack1Arr=
  array[1..maxstack1] of ShortInt;
 TStack=record
  Top:word;
  IStack:TStackArr
 end;
 TStack1=record
  Top:word;
  IStack:TStack1Arr
 end;
 T2DFunc=
  function(x:real):real;
 T3DFunc=
  function(x,y:real):real;

procedure ToRpn(const s:string;var MathRec:TMathRecord;var ErrorCode:integer);
procedure WriteRpn(const MathRec:TMathRecord);
procedure EvaluateRpn(const MathRec:TMathRecord;var ErrorCode:Integer;var Result:real);
procedure InitMathRec(var MathRec:TMathRecord);
procedure SetVariables(const Ix,Iy:real);

implementation

var
 Stack:TStack;
 Stack1:TStack1;
 x,y:real;

procedure InitMathRec(var MathRec:TMathRecord);
var
 i:word;
begin
 for i:=1 to maxrec do
 begin
  MathRec.I[i].Number:=0;
  MathRec.I[i].Code:=0
 end;
 MathRec.Length:=0;
end;

procedure InitStack;
var
 i:word;
begin
 for i:=1 to maxstack do
  Stack.IStack[i]:=0;
 Stack.Top:=1
end;

procedure Push(const x:Real);
begin
 if Stack.Top>maxstack then
  writeln('Stack over...')
                       else
 begin
  Stack.IStack[Stack.Top]:=x;
  inc(Stack.Top)
 end
end;

function Pop(var x:Real):boolean;
begin
 if Stack.Top<1 then
  pop:=false
                else
 begin
  dec(Stack.Top);
  x:=Stack.IStack[Stack.Top];
  pop:=true
 end;
end;

procedure InitStack1;
var
 i:word;
begin
 for i:=1 to maxstack1 do
  Stack1.IStack[i]:=0;
 Stack1.Top:=1
end;

procedure Push1(const x:ShortInt);
begin
 if Stack1.Top>maxstack1 then
  writeln('Stack1 over...')
                       else
 begin
  Stack1.IStack[Stack1.Top]:=x;
  inc(Stack1.Top)
 end
end;

function Pop1(var x:ShortInt):boolean;
begin
 if Stack1.Top<1 then
  pop1:=false
                else
 begin
  dec(Stack1.Top);
  x:=Stack1.IStack[Stack1.Top];
  pop1:=true
 end;
end;

function GetCode(const s:string):ShortInt;
begin
 GetCode:=0;
 if s='sin' then
  GetCode:=-1;
 if s='cos' then
  GetCode:=-2;
 if s='tg' then
  GetCode:=-3;
 if s='ctg' then
  GetCode:=-4;
 if s='exp' then
  GetCode:=-5;
 if s='ln' then
  GetCode:=-6;
 if s='x' then
  GetCode:=127;
 if s='y' then
  GetCode:=126;
 if s='r' then
  GetCode:=125;
 if s='a' then
  GetCode:=124;
end;


function Eval(const x:real;Code:ShortInt):real;
begin
 Eval:=0;
 if Code=-1 then
  Eval:=sin(x);
 if Code=-2 then
  Eval:=cos(x);
 if Code=-3 then
  Eval:=sin(x)/cos(x);
 if Code=-4 then
  Eval:=cos(x)/sin(x);
 if Code=-5 then
  Eval:=exp(x);
 if Code=-6 then
  Eval:=ln(x);
end;

procedure ToRpn;
var
 i,j,k,l:word;
 code,ss:ShortInt;
 num:real;
 err:boolean;
 ValErr:integer;
 s1,funcs:string;

begin
 InitStack1;
 l:=length(s);
 i:=1;k:=1;
 while i<=l do
 begin

  if s[i]=' ' then inc(i);

  if (s[i] in NumSet) then
  begin
   j:=1;
   while (s[i+j] in NumSet) do
    inc(j);
   s1:=copy(s,i,j);
   val(s1,num,ValErr);
   if ValErr<>0 then
   begin
    ErrorCode:=5;
    InitMathRec(MathRec);
    Exit
   end;
   MathRec.I[k].Number:=num;
   MathRec.I[k].Code:=0;
   inc(k);
   while ((Stack1.IStack[Stack1.Top-1]<0) and (Stack1.Top>1)) do
   begin
    err:=pop1(ss);
    MathRec.I[k].Number:=0;
    MathRec.I[k].Code:=ss;
    inc(k);
   end;
   i:=i+j;
  end;

  if (s[i] in FuncSet) then
  begin
   j:=0;
   while ((S[i+j] in FuncSet) or (S[i+j] in NumSet)) do
    inc(j);
   funcs:=copy(S,i,j);
   Code:=GetCode(funcs);
   push1(code);
   i:=i+j;
  end;

  if (s[i] in VarSet) then
  begin
   MathRec.I[k].Number:=0;
   MathRec.I[k].Code:=GetCode(s[i]);
   inc(k);
   inc(i);
  end;

  if (s[i] in OperSet) then
  begin
   ss:=0;
   case s[i] of
    '(':push1(5);
    ')':repeat
         err:=pop1(ss);
         if not err then
         begin
          ErrorCode:=1;
          InitMathRec(MathRec);
          exit;
         end;
         if ss<>5 then
         begin
          MathRec.I[k].Number:=0;
          MathRec.I[k].Code:=ss;
          inc(k)
         end
        until ss=5;
    '+':begin
         while ((Stack1.Top>1) and (Stack1.IStack[Stack1.Top-1]<5)) do
         begin
          err:=pop1(ss);
          MathRec.I[k].Number:=0;
          MathRec.I[k].Code:=ss;
          inc(k)
         end;
         push1(3);
        end;
    '-':begin
         while ((Stack1.Top>1) and (Stack1.IStack[Stack1.Top-1]<5)) do
         begin
          err:=pop1(ss);
          MathRec.I[k].Number:=0;
          MathRec.I[k].Code:=ss;
          inc(k)
         end;
         push1(4);
        end;
    '*':begin
         while ((Stack1.IStack[Stack1.Top-1] < 3) and (Stack1.Top>1)) do
         begin
          err:=pop1(ss);
          MathRec.I[k].Number:=0;
          MathRec.I[k].Code:=ss;
          inc(k)
         end;
         push1(1);
        end;
    '/':begin
         while ((Stack1.IStack[Stack1.Top-1] < 3) and (Stack1.Top>1)) do
         begin
          err:=pop1(ss);
          MathRec.I[k].Number:=0;
          MathRec.I[k].Code:=ss;
          inc(k)
         end;
         push1(2);
        end;
   end;
   inc(i);
  end;
 end;
 while Stack1.Top>1 do
 begin
  err:=pop1(ss);
  MathRec.I[k].Code:=ss;
  MathRec.I[k].Number:=0;
  inc(k)
 end;
 MathRec.Length:=k-1
end;

procedure WriteRpn;
var
 i:word;
begin
 for i:=1 to MathRec.Length do
 begin
  if MathRec.I[i].Code=0 then
   write(MathRec.I[i].Number:3:3,' ');
  if MathRec.I[i].Code<>0 then
   write(Oper[MathRec.I[i].Code],' ')
 end;
end;

procedure EvaluateRpn;
var
 res1,res2:boolean;
 v1,v2,res:real;
 i:word;
begin
 InitStack;
 for i:=1 to MathRec.Length do
 begin
  if MathRec.I[i].Code=0 then
   Push(MathRec.I[i].Number);

  if (MathRec.I[i].Code>100) then
  begin
   if (MathRec.I[i].Code=127) then
    push(x);
   if (MathRec.I[i].Code=126) then
    push(y);
  end;

  if (MathRec.I[i].Code<0) then
  begin
   res1:=pop(v1);
   if not res1 then
   begin
    ErrorCode:=1;
    Result:=0;
    exit
   end;
   res:=Eval(v1,MathRec.I[i].Code);
   push(res);
  end;

  if ((MathRec.I[i].Code>0) and (MathRec.I[i].Code<100)) then
  begin
   res1:=pop(v1);
   res2:=pop(v2);
   if not (res1 and res2) then
   begin
    ErrorCode:=1;
    Result:=0;
    exit
   end;
   case MathRec.I[i].Code of
    1:res:=v1*v2;
    4:res:=v2-v1;
    3:res:=v1+v2;
    2:begin
       if v1=0 then
       begin
        ErrorCode:=3;
        Result:=0;
        exit
       end;
       res:=v2/v1
      end
   end;
   push(res)
  end
 end;
  pop(res);
  Result:=res;
end;

procedure SetVariables;
begin
 x:=Ix;
 y:=Iy;
end;

end.
