unit Upr1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Menus, Gr3D, Calculator;

const
 AboutInfo:array[1..8] of string=
  (' _________Graph 3D 1.0_____________',
   'A program for building 3D graphs   ',
   'of simple mathematical functions   ',
   '   (c) Pavel Buividovich 2002      ',
   'mailto:buividovich@tut.by          ',
   '***********************************',
   'Please advise me how to upgrade    ',
   'this program. Thanks !!!           ');
  HelpInfo:array[1..21] of string=
  ('Input your arithmetic expression   ',
   'in the Text Box, using small chars ',
   'in the names of the functions and  ',
   'press OK. To rotate the graph  in  ',
   'horizontal plate use H+/H- buttons,',
   'in vertical plate - V+/V- buttons. ',
   'Use RR button to reset the rotation',
   'and X button to clear screen.      ',
   'Use three text boxes to load the   ',
   'lighting vector                    ',
   'You may draw graphs in decarte,    ',
   'axial and polar coordinates.       ',
   'X and Y is hor. and vert. angles in',
   'polar coordinates,hor. angle and   ',
   'radius in axial coordinates. You   ',
   'can use sin,cos,tg,ctg,ln,exp      ',
   'functions. Its a pity, but errors  ',
   'such as tg(pi/2) may occur here    ',
   'and only positive numbers is       ',
   'interpreted rightly. This will be  ',
   'abolished in the next versions.    ');

type
  TForm1 = class(TForm)
    RotateHorIncBtn: TButton;
    RotateHorDecBtn: TButton;
    RotateVertIncBtn: TButton;
    RotateVertDecBtn: TButton;
    MainMenu1: TMainMenu;
    EvaluateMIT: TMenuItem;
    PolarBlt: TMenuItem;
    Decarte: TMenuItem;
    Axial: TMenuItem;
    ZeroBlt: TMenuItem;
    Help: TMenuItem;
    HowToUse: TMenuItem;
    About: TMenuItem;
    ClearBtn: TButton;
    RtResetBtn: TButton;
    Formulae: TEdit;
    EvalBtn: TButton;
    View1: TMenuItem;
    SurfaceMode1: TMenuItem;
    GridMode1: TMenuItem;
    LightX: TEdit;
    LightY: TEdit;
    LightZ: TEdit;
    LightBtn: TButton;
    Label1: TLabel;
    Button1: TButton;
    procedure RotateHorIncBtnClick(Sender: TObject);
    procedure RotateHorDecBtnClick(Sender: TObject);
    procedure RotateVertDecBtnClick(Sender: TObject);
    procedure RotateVertIncBtnClick(Sender: TObject);
    procedure DecarteClick(Sender: TObject);
    procedure PolarBltClick(Sender: TObject);
    procedure AxialClick(Sender: TObject);
    procedure ZeroBltClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ClearBtnClick(Sender: TObject);
    procedure RtResetBtnClick(Sender: TObject);
    procedure EvalBtnClick(Sender: TObject);
    procedure SurfaceMode1Click(Sender: TObject);
    procedure GridMode1Click(Sender: TObject);
    procedure AboutClick(Sender: TObject);
    procedure HowToUseClick(Sender: TObject);
    procedure LightBtnClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  X,Y:real;
  Pos,LPos:TPolar;
  Formula:TMathRecord;
  FormStr:string;
  Error,Ans:integer;
  Mode:Byte;
  GrMode:Boolean;

implementation

{$R *.dfm}

function Wave(x,y:real):real;
var
 s:real;
begin
 SetVariables(x,y);
 EvaluateRpn(Formula,Error,s);
 Wave:=s;
end;

function DemoFunc(x,y:real):real;
begin
 Demofunc:=100*sin(x/50)+100*cos(y/50);
end;

procedure TForm1.RotateHorIncBtnClick(Sender: TObject);
begin
 HorAngle:=HorAngle + DeltaAngle;
 LoadBasisEx;
 LoadBasis;
 ClearSpace;
 if GrMode then
  DrawEx
 else
  Draw;
 DrawBasis(100);
end;

procedure TForm1.RotateHorDecBtnClick(Sender: TObject);
begin
 HorAngle:=HorAngle - DeltaAngle;
 LoadBasisEx;
 LoadBasis;
 ClearSpace;
 if GrMode then
  DrawEx
 else
  Draw;
 DrawBasis(100);
end;

procedure TForm1.RotateVertDecBtnClick(Sender: TObject);
begin
 VertAngle:=VertAngle - DeltaAngle;
 LoadBasisEx;
 LoadBasis;
 ClearSpace;
 if GrMode then
  DrawEx
 else
  Draw;
 DrawBasis(100);
end;

procedure TForm1.RotateVertIncBtnClick(Sender: TObject);
begin
 VertAngle:=VertAngle + DeltaAngle;
 LoadBasisEx;
 LoadBasis;
 ClearSpace;
 if GrMode then
  DrawEx
 else
  Draw;
 DrawBasis(100);
end;

procedure TForm1.DecarteClick(Sender: TObject);
begin
 Mode:=1;
 Axial.Checked:=false;
 PolarBlt.Checked:=false;
 Decarte.Checked:=true;
 ZeroBlt.Checked:=false;
 Evaluate(Wave);
 ClearSpace;
 if GrMode then
  DrawEx
 else
  Draw;
 DrawBasis(100);
end;

procedure TForm1.PolarBltClick(Sender: TObject);
begin
 Mode:=2;
 Axial.Checked:=false;
 PolarBlt.Checked:=true;
 Decarte.Checked:=false;
 ZeroBlt.Checked:=false;
 EvaluatePolar(Wave);
 ClearSpace;
 if GrMode then
  DrawEx
 else
  Draw;
 DrawBasis(100);
end;

procedure TForm1.AxialClick(Sender: TObject);
begin
 Mode:=3;
 Axial.Checked:=true;
 PolarBlt.Checked:=false;
 Decarte.Checked:=false;
 ZeroBlt.Checked:=false;
 EvaluateAxial(Wave);
 ClearSpace;
 if GrMode then
  DrawEx
 else
  Draw;
 DrawBasis(100);
end;

procedure TForm1.ZeroBltClick(Sender: TObject);
begin
 Evaluate(Gr_Zero);
 LoadBasisEx;
 LoadBasis;
 ClearSpace;
 if GrMode then
  DrawEx
 else
  Draw;
 DrawBasis(100);
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
 X2d0:=Form1.Width div 2;
 Y2d0:=Form1.Height div 2;
 GrForm:=Form1;
 InitMathRec(Formula);
 HorAngle:=0;
 VertAngle:=0;
 LoadBasis;
 LoadBasisEx;
 GrMode:=true;
 Mode:=1;
end;

procedure TForm1.ClearBtnClick(Sender: TObject);
begin
 ClearSpace;
 Pos.hor:=0;
 Pos.vert:=0;
 Pos.rad:=100;
 LPos:=Pos;
end;

procedure TForm1.RtResetBtnClick(Sender: TObject);
begin
 HorAngle:=0;
 VertAngle:=0;
 DeltaAngle:=pi/10;
 LoadBasis;
 LoadBasisEx;
 ClearSpace;
 if GrMode then
  DrawEx
 else
  Draw;
end;

procedure TForm1.EvalBtnClick(Sender: TObject);
begin
 InitMathRec(Formula);
 FormStr:=Formulae.Text;
 ToRpn(FormStr,Formula,Error);
 if Error<>0 then
  Ans:=Application.MessageBox('Syntax error !!!','Error!',MB_OK);
 Case Mode of
  1:Evaluate(Wave);
  2:EvaluatePolar(Wave);
  3:EvaluateAxial(Wave)
 else
  Evaluate(Gr_Zero)
 end;
 ClearSpace;
 if GrMode then
  DrawEx
 else
  Draw;
end;

procedure TForm1.SurfaceMode1Click(Sender: TObject);
begin
 GrMode:=true;
 SurfaceMode1.Checked:=true;
 GridMode1.Checked:=false;
 ClearSpace;
 DrawEx;
end;

procedure TForm1.GridMode1Click(Sender: TObject);
begin
 GrMode:=false;
 SurfaceMode1.Checked:=false;
 GridMode1.Checked:=true;
 ClearSpace;
 Draw;
end;

procedure TForm1.AboutClick(Sender: TObject);
var
 i,a:word;
 j:longint;
begin
 ClearSpace;
 Evaluate(DemoFunc);
 DrawEx;
 Canvas.Font.Color:=rgb($FF,$EA,$BA);
 Canvas.Font.Size:=20;
 Canvas.Font.Name:='Times New Roman';
 for i:=1 to 8 do
 begin
  Form1.Canvas.TextOut(100,40*i,AboutInfo[i]);
  for j:=1 to 200000000 do
   a:=a;
 end;
end;

procedure TForm1.HowToUseClick(Sender: TObject);
var
 i:word;
begin
 ClearSpace;
 Evaluate(DemoFunc);
 DrawEx;
 Canvas.Font.Color:=rgb($FF,$EA,$BA);
 Canvas.Font.Size:=10;
 for i:=1 to 21 do
 begin
  Form1.Canvas.TextOut(100,20*i,HelpInfo[i]);
 end;
end;

procedure TForm1.LightBtnClick(Sender: TObject);
var
 LX,LY,LZ:real;
begin
 Val(LightX.Text,LX,Error);
 Val(LightY.Text,LY,Error);
 Val(LightZ.Text,LZ,Error);
 if Error<>0 then
  Ans:=Application.MessageBox('Error in Light parameters','Error!',MB_OK);
 LoadLight(LX,LY,LZ);
 ClearSpace;
 if GrMode then
  DrawEx
 else
  Draw; 
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 ClearSpace;
 EvaluateTor;
 DrawEx;
end;

end.
